#pragma once
#include "BehaviorPerform.h"
#include <QUdpSocket>

class ConsolePresent : public ExecuteDelegate 
{
private:
	QHash<QString, std::shared_ptr<TopicData>> _input_list;
	QUdpSocket *const _write_port;

public:
	ConsolePresent();
	virtual ~ConsolePresent();

	QString typeName() const override;
	QHash<QString, std::shared_ptr<TopicData>> inputList() const override;
	QHash<QString, std::shared_ptr<TopicData>> outputList() const override;


	void reset() override;
	ExecuteResult execute() override;


	std::shared_ptr<Serializable> newDefault() const override;


	void recoveryFrom(const QJsonObject& obj) override;
	void saveTo(QJsonObject& obj) const override;

};